/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __alembic_SurfaceAccessibleAbc_h__
#define __alembic_SurfaceAccessibleAbc_h__

namespace fe
{

/**************************************************************************//**
    @brief Alembic Surface Binding

	@ingroup alembic
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleAbc:
	public SurfaceAccessibleJoint
{
	public:
								SurfaceAccessibleAbc(void):
									m_pArchive(NULL)						{}
virtual							~SurfaceAccessibleAbc(void)					{}

								//* as SurfaceAccessibleI

virtual	BWORD					load(String a_filename,Real a_frame,
										sp<StringFilterI> a_spFilter);

	private:

		void					visit(Alembic::AbcGeom::IObject a_iObj);

		void					visitProperty(
										Alembic::AbcGeom::IScalarProperty
										a_properties,
										String a_indent);
		void					visitProperty(
										Alembic::AbcGeom::IArrayProperty
										a_properties,
										String a_indent);
		void					visitProperty(
										Alembic::AbcGeom::ICompoundProperty
										a_properties,
										String& a_rIndent);
		void					visitProperties(
										Alembic::AbcGeom::ICompoundProperty
										a_properties,
										String& a_rIndent);

		Alembic::AbcGeom::IArchive*	m_pArchive;
		String						m_filename;
		SpatialTransform			m_refWorld;
};

} // namespace

#endif /* __alembic_SurfaceAccessibleAbc_h__ */
