/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "network.pmh"

namespace fe
{

SignalSender::SignalSender(int sid, sp<Scope> spScope, sp<ChunkSpool> spChunkSpool)
{
	m_spScope = spScope;
	m_spStream = new data::BinaryStream(m_spScope);
	m_spChunkSpool = spChunkSpool;
	m_spRG = new RecordGroup();
	m_sid = sid;
	m_aSID.setup(spScope, "_SID_", "integer");
	m_maxspoolsize = 0;
}

SignalSender::~SignalSender(void)
{
}

void SignalSender::initialize(void)
{
}

void SignalSender::handle(Record &signal)
{
	int *sid = m_aSID.queryAttribute(signal);
	if(sid)
	{
		if(*sid == 0)
		{
			*sid = m_sid;
		}
		else if(*sid != (int)m_sid)
		{
			return;
		}
	}
	std::ostringstream ost;
	m_spRG->add(signal);
	m_spStream->output(ost, m_spRG);
	m_spRG->clear();

	sp<Chunk> spChunk(new Chunk(ost.str()));
	if((m_maxspoolsize == 0) || (m_spChunkSpool->size() < m_maxspoolsize))
	{
		m_spChunkSpool->put(spChunk.abandon());
	}
}

void SignalSender::bind(sp<SignalerI> spSignalerI, sp<Layout> spLayout)
{
}

} /* namespace */

