/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "oplab.pmh"
#include "platform/dlCore.cc"

using namespace fe;

extern "C"
{

FE_DL_EXPORT void ListDependencies(List<String*>& list)
{
#ifdef FE_USE_GRAPHVIZ
//	list.append(new fe::String("fexGraphVizDL"));
#endif

//	list.append(new String("fexNetworkDL"));
	list.append(new String("fexOperateDL"));
}

FE_DL_EXPORT Library* CreateLibrary(sp<Master> spMaster)
{
	assertMath(spMaster->typeMaster());

	Library *pLibrary = new Library();

	pLibrary->add<NexusOp>(
			"OperatorSurfaceI.NexusOp.fe.nohoudini");

	pLibrary->add<BindEditOp>(
			"OperatorSurfaceI.BindEditOp.fe.prototype");
	pLibrary->add<CurvaceousOp>(
			"OperatorSurfaceI.CurvaceousOp.fe.prototype");
	pLibrary->add<FusionOp>(
			"OperatorSurfaceI.FusionOp.fe.prototype");
	pLibrary->add<GridWrapOp>(
			"OperatorSurfaceI.GridWrapOp.fe.prototype");
	pLibrary->add<RecordOp>(
			"OperatorSurfaceI.RecordOp.fe.prototype");
	pLibrary->add<XRayOp>(
			"OperatorSurfaceI.XRayOp.fe.prototype");

	return pLibrary;
}

FE_DL_EXPORT void InitializeLibrary(sp<Library> spLibrary)
{
#if FALSE
	sp<Registry> spRegistry=spLibrary->registry();

	//* load Alembic support
	String nameOrder="fexAlembic10102:fexAlembic";
	String name;
	while(!(name=nameOrder.parse("\"",":")).empty())
	{
		if(successful(spRegistry->manage(name)))
		{
			if(System::getVerbose()=="all")
			{
				feLog("  using %s\n",name.c_str());
			}
			return;
		}
	}
#endif
}

}
