/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __vegetation_SketchI_h__
#define __vegetation_SketchI_h__

namespace fe
{

/**************************************************************************//**
	@brief Generic drawable object

	@ingroup vegetation

	This can be useful for holding internal cached state.
*//***************************************************************************/
class FE_DL_EXPORT SketchI: virtual public Component
{
	public:

#if FE_VEG_VIEWER
virtual	void				bind(sp<ControllerI> spControllerI)				=0;
#endif
virtual	void				bind(sp<Component> spComponent)					=0;
virtual	void				draw(sp<DrawI> spDrawI)							=0;

virtual	SpatialTransform	transform(void) const							=0;
virtual	void				setTransform(SpatialTransform a_transform)		=0;

virtual	void				setPaused(BWORD paused)							=0;
virtual	BWORD				paused(void) const								=0;
};

} /* namespace */

#endif /* __vegetation_SketchI_h__ */
